/*  Выдать на Пульт акции Бота

вывести на Пульт действия Бота строкой lib.SentActionsForPult("xcvxvxcv")
Каждая акция - в формате: вид действия (1 - действие рефлекса, 2 - фраза) затем строка акции,
например: "1|Предлогает поиграть" или "2|Привет!"
Можно передавать неограниченную последовательность акций, разделяя их "||"
например: "1|Предлогает поиграть||2|Привет!"
*/

package reflexes

import (
	"BOT/brain/action_sensor"
	"BOT/brain/gomeostas"
	"BOT/lib"
)

// выдать на Пульт подряд акции одного безусловного рефлекса
func TerminateGeneticReflaxActions(id int){
	if id==0{
		return
	}
	reflex:=GeneticReflexes[id]
	if reflex==nil{return}
	var out="1|"
	for i := 0; i < len(reflex.ActionIDarr); i++ {
		if i>0{out +=", "}
		out += TerminalActonsNameFromID[reflex.ActionIDarr[i]]
	}
lib.SentActionsForPult(out)
	return
}
/////////////////////////////////////////////

// выдать на Пульт подряд акции массива ID безусловных рефлексов
func TerminateGeneticAllReflaxActions(reflexesIdArr []int){
	if reflexesIdArr==nil{
		return
	}
	var out="1|"
	// оставить только уникальные действия рефлексов и выдать такой список
	var unicumArr=make(map[int]int)
	for i := 0; i < len(reflexesIdArr); i++ {
		reflex:=GeneticReflexes[reflexesIdArr[i]]
		for j := 0; j < len(reflex.ActionIDarr); j++ {
			unicumArr[reflex.ActionIDarr[j]]=1
		}
	}
	var n=0
	for k, _ := range unicumArr {
		// если Бот пытается поесть
		if k==5{
			res:=botEatingFood()
			if res==0{// если нет еды
				k=77 //нет еды! Накорми!
			}
			if res==2{// уже насен и не может есть
				k=78 // не хочу больше есть
			}
		}
		if n>0{out +=", "}
		out += TerminalActonsNameFromID[k]
		n++
	}
	lib.SentActionsForPult(out)
	return
}
////////////////////////////////////
// выдать на Пульт подряд акции массива по каждому рефлексу отдельной строкой действий
// пока НЕ ИСПОЛЬЗУЕТСЯ
func TerminateGeneticEachReflaxActions(reflexesIdArr []int){
	if reflexesIdArr==nil{
		return
	}
	var out=""
	for i := 0; i < len(reflexesIdArr); i++ {
		if i>0{out+="||"} // пошел следующий рефлекс
		reflex:=GeneticReflexes[reflexesIdArr[i]]
		if reflex==nil{return}
		out+="1|"
		for j := 0; j < len(reflex.ActionIDarr); j++ {
			if j>0{out +=", "}
			out += TerminalActonsNameFromID[reflex.ActionIDarr[j]]
		}
	}
	lib.SentActionsForPult(out)
}
///////////////////////////////////////////////


////////////  БОТ кормится из выданной порции
// один акт кормления пополняет энергию на 30%
func botEatingFood()(int){
	// сколько сможет съесть? сколько отсалось до 100
	energi:=gomeostas.GomeostazParams[1]
	can:=100-gomeostas.GomeostazParams[1]
	if energi>95{// больше не хочет есть
		return 2
	}
	var portion=30
	if can<30{
		portion=int(30-can)
	}
		if action_sensor.FoodPortionForEnergi>=portion{// еды больше порции
// сколько Бот уже съел и нужно превратить в энергию (сразу писать нельзя из-за паники: "concurrent map read and map write")
		gomeostas.FoodPortionEaten+=action_sensor.FoodPortionForEnergi
		action_sensor.FoodPortionForEnergi-=portion
		if action_sensor.FoodPortionForEnergi<0{
			action_sensor.FoodPortionForEnergi=0
		}
		return 1
	}else{// еды меньше порции
			if action_sensor.FoodPortionForEnergi<10{
				gomeostas.FoodPortionEaten+=action_sensor.FoodPortionForEnergi
				action_sensor.FoodPortionForEnergi=0
				return 0
			}
		gomeostas.FoodPortionEaten+=portion
		action_sensor.FoodPortionForEnergi-=portion
		if action_sensor.FoodPortionForEnergi<0{
			action_sensor.FoodPortionForEnergi=0
		}
		return 1
	}


return 0
}
/////////////////////////////////////////////


